<?php
namespace MyMeals\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use MyMeals\Services\JWT;
use MyMeals\Services\Shifts as ShiftsService;

class Shifts {

    const SESSION_NAME = "session";

    protected $shiftsService;

    public function __construct(ShiftsService $shiftsService) {
        $this->shiftsService = $shiftsService;
    }

    public function getShifts(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $filterCriteria = $request->getFilterCriteria();
            $dataSet = $this->shiftsService->findShiftsByMenuDate($filterCriteria);
            $response->addDataSet($dataSet);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
}