<?php
namespace MyMeals\Services;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\Events\PreDispatch\Listener;
use MyMeals\Services\JWT;
use MyMeals\Exceptions;
use MyMeals\Util\RequestHeader;

class PreDispatch extends Listener {

    private $ignoredRoutes = array("/login", "/testConnection");

    public function preDispatch(Request $request) {
        if (!in_array($request->getRoutePath(), $this->ignoredRoutes)) {
            $token = RequestHeader::getKey("session");
            if($token){
                $validToken = JWT::validateToken($token);
                if (!$validToken) {
                    throw new Exceptions\InvalidTokenException();
                }
            } else {
                throw new Exceptions\InvalidTokenException();
            }
        }
    }
}