module.exports = function (grunt) {
	
	var srcFiles = {
		js: ["src/assets/js/controllers/**/*.js"],
		less: ["src/assets/css/**/*.less"],
		html: ["src/templates/**/*.html"]
	};

	grunt.initConfig({
		copy: {
			main: {
				files: [
					{
						expand: true,
						cwd: 'src/',
						src: 'templates/**/*',
						dest: 'dist/'
					}
				]
			}
		},
		bump: {
			options: {
				files: ['bower.json', 'package.json'],
				pushTo: 'origin',
				commitFiles: ["-a"],
				push: true
			}
		},
		less: {
			development: {
				options: {
					compress: true,
					modifyVars: {
						fontFamily:'OpenSans, san serif'
					}
				},
				files: {
					'dist/splash.css': srcFiles.less
				}
			}
		}
	});

	grunt.loadNpmTasks('grunt-contrib-less');
	grunt.loadNpmTasks('grunt-contrib-watch');
	grunt.loadNpmTasks('grunt-contrib-copy');
	grunt.loadNpmTasks('grunt-bump');
	
	grunt.registerTask('default', ['copy', 'less']);
};