describe("AclEngine", function () {

	var templateAcl = null;
	var templateComponents = null;
	var menus = null;
	var parentMenu = null;
	var userGroupId = null;
	var container = null;
	var parentContainer = null;
	var aclEngine = null;

	beforeEach(function () {
		templateAcl = {
			"150241018": {
				"type": "menu",
				"itemName": "parentMenu1",
				"userGroups": {
					"0001": {
						"rule": "A"
					}
				}
			},
			"518461": {
				"type": "menu",
				"itemName": "parentMenu2",
				"userGroups": {
					"0001": {
						"rule": "I"
					}
				}
			},
			"1984920": {
				"itemId": 10001,
				"type": "menu 1",
				"container": [
					"container1"
				],
				"userGroups": {
					"0001": {
						"rule": "A"
					},
					"0002": {
						"rule": "A"
					}
				}
			},
			"198425": {
				"itemId": 10002,
				"type": "menu 2",
				"container": [
					"container2"
				],
				"userGroups": {
					"0001": {
						"rule": "I"
					},
					"0002": {
						"rule": "A"
					}
				}
			},
			"485491548911": {
				"itemId": 10003,
				"type": "menu 3",
				"container": [
					"container3"
				],
				"userGroups": {
					"0001": {
						"rule": "R"
					},
					"0002": {
						"rule": "A"
					}
				}
			},
			"100347549758": {
				"type": "container",
				"itemName": "container1",
				"children": ["widget1"],
				"userGroups": {
					"0001": {
						"rule": "A"
					}
				}
			},
			"container15": {
				"type": "container",
				"itemName": "container15",
				"children": ["widget1"],
				"userGroups": {
					"0001": {
						"rule": "I"
					}
				}
			},
			"widget16": {
				"type": "widget",
				"itemName": "widget16",
				"userGroups": {
					"0001": {
						"rule": "A"
					}
				}
			},
			"548115975": {
				"itemName": "widget1",
				"type": "widget",
				"children": ["save", "delete", "field1"],
				"userGroups": {
					"0001": {
						"rule": "A"
					}
				}
			},
			"widget3": {
				"itemName": "widget3",
				"type": "widget",
				"children": ["field3"],
				"userGroups": {
					"0001": {
						"rule": "I"
					}
				}
			},
			"947582": {
				"type": "action",
				"itemName": "save",
				"userGroups": {
					"0001": {
						"rule": "I"
					}
				}
			},
			"2558532": {
				"type": "action",
				"itemName": "delete",
				"userGroups": {
					"0001": {
						"rule": "A"
					}
				}
			},
			"88932532": {
				"type": "field",
				"itemName": "field1",
				"userGroups": {
					"0001": {
						"rule": "A"
					}
				}
			},
			"1003475498": {
				"type": "container",
				"itemName": "container2",
				"userGroups": {
					"0001": {
						"rule": "A"
					}
				}
			},
			"1254833525": {
				"type": "widget",
				"itemName": "widget15",
				"userGroups": {
					"0001": {
						"rule": "I"
					}
				}
			}
		};
		templateComponents = {
			"project": {
				"name": "project 1",
				"menuTemplate": "menu/menu.html",
				"mainWindow": "container1",
				"menuChildTemplate": "menu/menu_child.html",
				"groupMenu": [
					{
						"id": 150241018,
						"name": "parentMenu1",
						"label": "parentMenu1",
						"hasChild": true,
						"menus": [
							{
								"id": 1984920,
								"label": "menu1",
								"name": "menu1",
								"windowName": "container4",
								"icon": "home icon-white"
							}, {
								"id": 1248532,
								"label": "menu4",
								"name": "menu4",
								"windowName": "container3",
								"icon": "home icon-white"
							}
						]
					}, {
						"id": 518461,
						"name": "parentMenu2",
						"hasChild": true,
						"menus": [
							{
								"id": 12515412,
								"name": "menu1",
								"windowName": "container1",
								"hasChild": false
							},
							{
								"id": 198425,
								"name": "menu2",
								"windowName": "container2",
								"hasChild": true,
								"menus": [
									{
										"id": 485491548911,
										"name": "menu3",
										"containerName": "widget3",
										"hasChild": true,
										"menus": [
											{
												"name": "menu6",
												"containerName": "widget6",
												"hasChild": false
											}
										]
									},
									{
										"id": 44444,
										"name": "menu4",
										"containerName": "widget4",
										"hasChild": false,

									},
									{
										"name": "menu5",
										"containerName": "widget5",
										"hasChild": false
									}
								]
							}
						]
					}, {
						"id": 12854152,
						"name": "parentMenu3",
						"label": "parentMenu3"
					}
				]
			},
			"container0": {
				"id": 1003475497,
				"name": "container0",
			},
			"container1": {
				"id": 100347549758,
				"name": "container1",
				"isVisible": true,
				"widgets": [
					{
						"id": 548115975,
						"name": "widget1",
						"isVisible": true,
						"actions": [
							{
								"id": 947582,
								"name": "save",
								"isVisible": true
							}, {
								"id": 2558532,
								"name": "delete",
								"isVisible": true
							}
						],
						"fields": [
							{
								"id": 2548552,
								"name": "field1"
							}, {
								"id": 9958442,
								"name": "field2"
							}
						]
					}, {
						"id": 95542412,
						"name": "widget3",
						"isVisible": true,
						"actions": [],
						"fields": []
					}, {
						"id": 3355482,
						"name": "widget4",
						"isVisible": true,
						"actions": [],
						"fields": []
					}, {
						"id": 1254833525,
						"name": "widget15",
						"isVisible": true,
						"actions": [],
						"fields": []
					}
				]
			},
			"container2": {
				"id": 1003475498,
				"name": "container2",
				"isVisible": true,
				"widgets": [
					{
						"id": 9952732,
						"name": "widget2",
						"isVisible": true,
						"actions": [
							{
								"name": "save"
							}, {
								"name": "delete"
							}
						],
						"fields": [
							{
								"id": 88932532,
								"name": "field1"
							}, {
								"id": 3354852,
								"name": "field2"
							}
						],
						"widgets": [
							{
								"id": 485224482,
								"name": "widget3",
								"isVisible": true,
								"actions": [],
								"fields": [
									{
										"id": 95591432,
										"name": "field3",
										"isVisible": true
									}
								]
							}
						]
					}
				]
			},
			"container15": {
				"id": 54455445488,
				"name": "container15",
				"widgets": [
					{
						"id": 999558844,
						"name": "widget16",
					}
				]
			}
		};
		menus = templateComponents.project.groupMenu;
		container = templateComponents.container1;
		parentContainer = null;
		parentMenu = null;
		userGroupId = "0001";
		aclEngine = new AclEngine();
	});

	it("MENUGROUP: SINGLE LEVEL => Set ACL 'invisible' if the component doesn't have a acl rule and defaultRule is undefined.", function () {
		aclEngine.processMenuAcl(menus, templateAcl, templateComponents, userGroupId);

		expect(menus[2].aclReadOnly).toEqual(false);
		expect(menus[2].aclIsVisible).toEqual(false);
		expect(menus[2].id).toBe(12854152);

	});

	it("MENUGROUP: SINGLE LEVEL => Set ACL 'default rule' if the component doesn't have a acl rule.", function () {
		aclEngine.processMenuAcl(menus, templateAcl, templateComponents, userGroupId, 'A');

		expect(menus[2].aclReadOnly).toEqual(false);
		expect(menus[2].aclIsVisible).toEqual(true);
		expect(menus[2].id).toBe(12854152);

		aclEngine.processMenuAcl(menus, templateAcl, templateComponents, userGroupId, 'I');

		expect(menus[2].aclReadOnly).toEqual(false);
		expect(menus[2].aclIsVisible).toEqual(false);
		expect(menus[2].id).toBe(12854152);

		aclEngine.processMenuAcl(menus, templateAcl, templateComponents, userGroupId, 'R');

		expect(menus[2].aclReadOnly).toEqual(true);
		expect(menus[2].aclIsVisible).toEqual(true);
		expect(menus[2].id).toBe(12854152);
	});

	it("MENUGROUP: SINGLE LEVEL => Set ACL 'read only':  Must set aclReadOnly = true and aclIsVisible = true", function () {
		templateAcl["12854152"] = { "type": "menu", "itemName": "parentMenu3", "userGroups": { "0001": { "rule": "R" } } };

		aclEngine.processMenuAcl(menus, templateAcl, templateComponents, userGroupId);

		expect(menus[2].aclReadOnly).toEqual(true);
		expect(menus[2].aclIsVisible).toEqual(true);
		expect(menus[2].id).toEqual(12854152);
	});

	it("MENUGROUP: SINGLE LEVEL => Set ACL 'invisible': Must set aclReadOnly = false and aclIsVisible = false", function () {
		templateAcl["12854152"] = { "type": "menu", "itemName": "parentMenu3", "userGroups": { "0001": { "rule": "I" } } };

		aclEngine.processMenuAcl(menus, templateAcl, templateComponents, userGroupId);

		expect(menus[2].aclReadOnly).toEqual(false);
		expect(menus[2].aclIsVisible).toEqual(false);
		expect(menus[2].id).toBe(12854152);
	});

	it("MENUGROUP: MULTI LEVEL => Children without ACL must have its parent's original configuration of ACL (aclReadOnly = false and aclIsVisible = false).", function () {
		templateAcl["150241018"].userGroups["0001"].rule = "I";
		aclEngine.processMenuAcl(menus, templateAcl, templateComponents, userGroupId);
		var childWithoutACL = menus[0].menus[1];

		expect(menus[0].aclReadOnly).toEqual(false);
		expect(menus[0].aclIsVisible).toEqual(true);
		expect(menus[0].id).toBe(150241018);

		expect(templateAcl["150241018"].userGroups["0001"].rule).toBe('I');
		expect(childWithoutACL.aclReadOnly).toEqual(false);
		expect(childWithoutACL.aclIsVisible).toEqual(false);
		expect(childWithoutACL.id).toBe(1248532);
	});

	it("MENUGROUP: MULTI LEVEL => Children with ACL must have its own configuration of ACL: 'readonly' (aclReadOnly = true and aclIsVisible = true).", function () {
		templateAcl["1984920"].userGroups["0001"].rule = "R";
		aclEngine.processMenuAcl(menus, templateAcl, templateComponents, userGroupId);

		expect(menus[0].aclReadOnly).toEqual(false);
		expect(menus[0].aclIsVisible).toEqual(true);
		expect(menus[0].id).toBe(150241018);

		expect(templateAcl["1984920"].userGroups["0001"].rule).toBe('R');
		expect(templateComponents[menus[0].menus[0].windowName].isAccessible).toEqual(false);
		expect(menus[0].menus[0].aclReadOnly).toEqual(true);
		expect(menus[0].menus[0].aclIsVisible).toEqual(true);
	});

	it("MENUGROUP: MULTI LEVEL => Children with ACL must have its own configuration of ACL: 'invisible' (aclReadOnly = false and aclIsVisible = false).", function () {
		templateAcl["1984920"].userGroups["0001"].rule = "I";
		aclEngine.processMenuAcl(menus, templateAcl, templateComponents, userGroupId);

		expect(menus[0].aclReadOnly).toEqual(false);
		expect(menus[0].aclIsVisible).toEqual(true);
		expect(menus[0].id).toBe(150241018);

		expect(templateAcl["1984920"].userGroups["0001"].rule).toBe('I');
		expect(menus[0].menus[0].aclReadOnly).toEqual(false);
		expect(menus[0].menus[0].aclIsVisible).toEqual(false);
	});

	it("MENUGROUP: MULTI LEVEL => Grandchildren without ACL must have its grandparent's original configuration of ACL (or parent's acl rules if it has). (aclReadOnly = false and aclIsVisible = false).", function () {
		aclEngine.processMenuAcl(menus, templateAcl, templateComponents, userGroupId);

		expect(menus[1].aclReadOnly).toEqual(false);
		expect(menus[1].aclIsVisible).toEqual(true);
		expect(menus[1].id).toBe(518461);

		expect(menus[1].menus[1].aclReadOnly).toEqual(false);
		expect(menus[1].menus[1].aclIsVisible).toEqual(true);
		expect(menus[1].menus[1].id).toBe(198425);

		expect(menus[1].menus[1].menus[1].aclReadOnly).toEqual(false);
		expect(menus[1].menus[1].menus[1].aclIsVisible).toEqual(false);
		expect(menus[1].menus[1].menus[1].id).toBe(44444);
	});

	it("MENUGROUP: MULTI LEVEL => Up propagation: A parent component must have its ACL configuration equal to 'Allow All', if one of its children has a more permissive rule.", function () {
		aclEngine.processMenuAcl(menus, templateAcl, templateComponents, userGroupId);

		expect(menus[1].menus[1].aclReadOnly).toEqual(false);
		expect(menus[1].menus[1].aclIsVisible).toEqual(true);
		expect(menus[1].menus[1].id).toBe(198425);
	});

	it("SINGLE LEVEL COMPONENT => Set ACL 'invisible' if the component doesn't have a acl rule and default rule is undefined.", function () {
		container = templateComponents.container0;
		aclEngine.processAcl(container, templateAcl, userGroupId);

		expect(container.aclReadOnly).toEqual(false);
		expect(container.aclIsVisible).toEqual(false);
		expect(container.id).toEqual(1003475497);
	});

	it("SINGLE LEVEL COMPONENT => Set ACL 'default rule' if the component doesn't have a acl rule.", function () {
		container = templateComponents.container0;
		aclEngine.processAcl(container, templateAcl, userGroupId, 'A');

		expect(container.aclReadOnly).toEqual(false);
		expect(container.aclIsVisible).toEqual(true);
		expect(container.id).toEqual(1003475497);

		aclEngine.processAcl(container, templateAcl, userGroupId, 'I');

		expect(container.aclReadOnly).toEqual(false);
		expect(container.aclIsVisible).toEqual(false);
		expect(container.id).toEqual(1003475497);

		aclEngine.processAcl(container, templateAcl, userGroupId, 'R');

		expect(container.aclReadOnly).toEqual(true);
		expect(container.aclIsVisible).toEqual(true);
		expect(container.id).toEqual(1003475497);
	});

	it("SINGLE LEVEL COMPONENT => Set ACL 'read only': must have aclReadOnly = true and aclIsVisible = true", function () {
		templateAcl["1003475497"] = { "type": "container", "itemName": "container0", "userGroups": { "0001": { "rule": "R" } } };
		container = templateComponents.container0;
		aclEngine.processAcl(container, templateAcl, userGroupId);

		expect(container.aclReadOnly).toEqual(true);
		expect(container.aclIsVisible).toEqual(true);
		expect(container.id).toEqual(1003475497);
	});

	it("SINGLE LEVEL COMPONENT => Set ACL 'invisible': must have aclReadOnly = false and aclIsVisible = false", function () {
		templateAcl["1003475497"] = { "type": "container", "itemName": "container0", "userGroups": { "0001": { "rule": "I" } } };
		container = templateComponents.container0;
		aclEngine.processAcl(container, templateAcl, userGroupId);

		expect(container.aclReadOnly).toEqual(false);
		expect(container.aclIsVisible).toEqual(false);
		expect(container.id).toEqual(1003475497);
	});

	it("PARENT TO CHILD INHERITANCE: Children without ACL must have its parent's original configuration of ACL (aclReadOnly = true and aclIsVisible = true).", function () {
		templateAcl["100347549758"].userGroups["0001"].rule = "R";
		aclEngine.processAcl(container, templateAcl, userGroupId);

		expect(container.aclReadOnly).toEqual(false);
		expect(container.aclIsVisible).toEqual(true);
		expect(container.id).toEqual(100347549758);

		expect(container.widgets[2].aclReadOnly).toEqual(true);
		expect(container.widgets[2].aclIsVisible).toEqual(true);
		expect(container.widgets[2].id).toEqual(3355482);
	});

	it("PARENT TO CHILD INHERITANCE: Children with ACL must have its own configuration of ACL (aclReadOnly = false and aclIsVisible = false). It should work if the acl rule is indexed by the element's name too.", function () {
		templateAcl["100347549758"].userGroups["0001"].rule = "R";
		aclEngine.processAcl(container, templateAcl, userGroupId);

		expect(container.aclReadOnly).toEqual(false);
		expect(container.aclIsVisible).toEqual(true);
		expect(container.id).toEqual(100347549758);

		expect(container.widgets[1].aclReadOnly).toEqual(false);
		expect(container.widgets[1].aclIsVisible).toEqual(false);
		expect(container.widgets[1].id).toEqual(95542412);
	});

	it("GRANDPARENT TO GRANDCHILD INHERITANCE:  Grandchildren without ACL must have its grandparent's original configuration of ACL (or parent's acl rules if it has). (aclReadOnly = true and aclIsVisible = true).", function () {
		container = templateComponents.container2;
		templateAcl["1003475498"].userGroups["0001"].rule = "R";
		aclEngine.processAcl(container, templateAcl, userGroupId);

		expect(container.aclReadOnly).toEqual(false);
		expect(container.aclIsVisible).toEqual(true);
		expect(container.id).toEqual(1003475498);

		expect(container.widgets[0].aclReadOnly).toEqual(false);
		expect(container.widgets[0].aclIsVisible).toEqual(true);
		expect(container.widgets[0].id).toEqual(9952732);

		expect(container.widgets[0].fields[1].aclReadOnly).toEqual(true);
		expect(container.widgets[0].fields[1].aclIsVisible).toEqual(true);
		expect(container.widgets[0].fields[1].id).toEqual(3354852);
	});

	it("GRANDPARENT TO GRANDCHILD INHERITANCE:  Grandchildren with ACL must have its own configuration of ACL. (aclReadOnly = false and aclIsVisible = true).", function () {
		container = templateComponents.container2;
		templateAcl["1003475498"].userGroups["0001"].rule = "R";
		aclEngine.processAcl(container, templateAcl, userGroupId);

		expect(container.aclReadOnly).toEqual(false);
		expect(container.aclIsVisible).toEqual(true);
		expect(container.id).toEqual(1003475498);

		expect(container.widgets[0].aclReadOnly).toEqual(false);
		expect(container.widgets[0].aclIsVisible).toEqual(true);
		expect(container.widgets[0].id).toEqual(9952732);

		expect(container.widgets[0].fields[0].aclReadOnly).toEqual(false);
		expect(container.widgets[0].fields[0].aclIsVisible).toEqual(true);
		expect(container.widgets[0].fields[0].id).toEqual(88932532);
	});

	it("WIDGET WITH CHILD WIDGETS (Popup): Test whether the current logic correctly handles all internal components and if a acl indexed by name works too.", function () {
		templateAcl["1003475498"].userGroups["0001"].rule = "R";
		container = templateComponents.container2;
		aclEngine.processAcl(container, templateAcl, userGroupId);

		expect(container.aclReadOnly).toEqual(false);
		expect(container.aclIsVisible).toEqual(true);
		expect(container.id).toBe(1003475498);

		expect(container.widgets[0].aclReadOnly).toEqual(false);
		expect(container.widgets[0].aclIsVisible).toEqual(true);
		expect(container.widgets[0].id).toBe(9952732);

		expect(container.widgets[0].fields[1].aclReadOnly).toEqual(true);
		expect(container.widgets[0].fields[1].aclIsVisible).toEqual(true);
		expect(container.widgets[0].fields[1].id).toBe(3354852);

		expect(container.widgets[0].widgets[0].aclReadOnly).toEqual(false);
		expect(container.widgets[0].widgets[0].aclIsVisible).toEqual(false);
		expect(container.widgets[0].widgets[0].id).toBe(485224482);

		expect(container.widgets[0].widgets[0].fields[0].aclReadOnly).toEqual(false);
		expect(container.widgets[0].widgets[0].fields[0].aclIsVisible).toEqual(false);
		expect(container.widgets[0].widgets[0].fields[0].id).toBe(95591432);
	});

	it("CHILD TO PARENT INHERITANCE (UP PROPAGATION)", function () {
		templateAcl["100347549758"].userGroups["0001"].rule = "I";
		aclEngine.processAcl(container, templateAcl, userGroupId);

		expect(container.aclReadOnly).toEqual(false);
		expect(container.aclIsVisible).toEqual(true);
		expect(container.id).toBe(100347549758);
	});

	it("GRANDCHILD TO PARENT INHERITANCE (UP PROPAGATION)", function () {
		templateAcl["100347549758"].userGroups["0001"].rule = "I";
		templateAcl["548115975"].userGroups["0001"].rule = "I";
		aclEngine.processAcl(container, templateAcl, userGroupId);

		expect(container.widgets[0].aclReadOnly).toEqual(false);
		expect(container.widgets[0].aclIsVisible).toEqual(true);
		expect(container.widgets[0].id).toBe(548115975);
	});

	it("CHILD TO PARENT INHERITANCE (UP PROPAGATION), even if the container and widget's acl rules are indexed by its names", function () {
		container = templateComponents.container15;
		aclEngine.processAcl(container, templateAcl, userGroupId);

		expect(container.aclReadOnly).toEqual(false);
		expect(container.aclIsVisible).toEqual(true);
		expect(container.name).toBe("container15");
	});

	it("GRANDCHILD TO GRANDPARENT AND PARENT INHERITANCE (UP PROPAGATION)", function () {
		container = templateComponents.container2;
		templateAcl["1003475498"].userGroups["0001"].rule = "I";
		aclEngine.processAcl(container, templateAcl, userGroupId);

		expect(container.aclReadOnly).toEqual(false);
		expect(container.aclIsVisible).toEqual(true);
		expect(container.id).toBe(1003475498);

		expect(container.widgets[0].aclReadOnly).toEqual(false);
		expect(container.widgets[0].aclIsVisible).toEqual(true);
		expect(container.widgets[0].id).toBe(9952732);

		expect(container.widgets[0].fields[0].aclReadOnly).toEqual(false);
		expect(container.widgets[0].fields[0].aclIsVisible).toEqual(true);
		expect(container.widgets[0].fields[0].id).toBe(88932532);

		expect(container.widgets[0].fields[1].aclReadOnly).toEqual(false);
		expect(container.widgets[0].fields[1].aclIsVisible).toEqual(false);
		expect(container.widgets[0].fields[1].id).toBe(3354852);
	});

	it("Verifing if it's possible to set an ACL set of rules directly to a field.", function () {
		var field = templateComponents.container1.widgets[0].fields[0];
		aclEngine.processAcl(field, templateAcl, userGroupId, 'A');

		expect(field.aclReadOnly).toEqual(false);
		expect(field.aclIsVisible).toEqual(true);
	});
});