describe('MaskEngine', function() {
  it('MaskEngine should exists', function() {
    expect(MaskEngine).not.toEqual(undefined);
  });

  it('Should subcribe to keyup event and return true', function() {
    var maskEngine = new MaskEngine({});
    var element = {
      on: function(event, callback) {
        expect(event).toBe('keydown');
        expect(callback({ keyCode: 23 })).toBe(true);
      },
      bind: function(argument) {}
    };

    maskEngine.zerofill(element, false, { acceptOnlyNumbers: true });
  });

  it('Should subcribe to keyup event and return false', function() {
    var maskEngine = new MaskEngine({});
    var element = {
      on: function(event, callback) {
        expect(event).toBe('keydown');
        expect(callback({ keyCode: 88 })).toBe(false);
      },
      bind: function(argument) {}
    };

    maskEngine.zerofill(element, false, { acceptOnlyNumbers: true });
  });

  it('fixMaskParser method should evaluate params.mask', function() {
    var zhUtil = jasmine.createSpyObj(['evaluate']);
    var maskEngine = new MaskEngine(zhUtil);
    var params = { mask: '' };
    maskEngine.fixMaskParser('', params);
    expect(zhUtil.evaluate).toHaveBeenCalledWith(params.mask);
  });

  it('fixParser method should evaluate params.mask', function() {
    var zhUtil = jasmine.createSpyObj(['evaluate']);
    var maskEngine = new MaskEngine(zhUtil);
    var params = { mask: '' };
    maskEngine.fixParser('', params);
    expect(zhUtil.evaluate).toHaveBeenCalledWith(params.mask);
  });
});
