function loginService($http, restEngine, ScreenService, templateManager) {

    var containerNames = ["change-unit", "Informacoes", "meals", "Pratos", "login"];

    this.login = function(row) {
        return restEngine.request('/login', {
            "requestType": "Row",
            "row": row
        }).then(function(response) {
            return response.dataset.user;
        }).catch(catchError);
    };

    this.removeUserData = function() {
        this.removeContainersFromProject(containerNames);
        setLocalVar("Session", "");
    };

    this.testConnection = function(url) {
        return restEngine.request('/testConnection', {
            "requestType": "Empty"
        }, null, null, null, url);
    };

    this.removeContainersFromProject = function(containersToRemove) {
        containersToRemove = containersToRemove || containerNames;
        containersToRemove.forEach(function(container) {
            delete templateManager.containers[container];
        });
    };

    this.compareVersion = function(serverVersion) {
        var status = "OK";
        var appVersion = window.appVersion;
        if (parseFloat(serverVersion) > parseFloat(appVersion)) {
            status = "newVersion";
        } else if (parseFloat(serverVersion) < parseFloat(appVersion)) {
            status = "serverOut";
        }

        return status;
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register("LoginService", loginService);
});
